package util.models;


public class ACartesianPoint implements GeneralizedPoint {
	int x, y;
	
	public ACartesianPoint(int initX, int initY) {
		x = initX;
		y = initY;
	}
	
	public ACartesianPoint(int theX) {
		x = theX;
		y = 0;
	}
	
	
	public int getX() {
		return x;
	}
	
	public void setX(int newX) {
		x = newX;
	}
	
	public int getY() {
		return y;
	}
	
	public void setY(int newY) {
		y = newY;
	}
	
	public double getAngle() {
		return Math.atan((double)y/x);
	}
	
	public void setAngle(double newAngle) {
		double currentRadius = getRadius();
		x = (int) (currentRadius*Math.cos(newAngle));
		y = (int) (currentRadius*Math.sin(newAngle));
	}
	
	public double getRadius() {
		return  Math.sqrt(x*x + y*y);
	}
	
	public void setRadius(double newRadius) {
		double currentAngle = getAngle();
		x = (int) (newRadius*Math.cos(currentAngle));
		y = (int) (newRadius*Math.sin(currentAngle));
	}
	
	
	static public GeneralizedPoint mid (GeneralizedPoint point1, GeneralizedPoint point2) {
		return new ACartesianPoint(point1.getX() + 
								      (point2.getX() - point1.getX())/2,
								   point1.getY() +
								       (point2.getY() - point1.getY())/2);
		
	}
}