package util.models;
import java.util.Collection;
public interface VectorMethodsListener<ElementType> {
	public void elementAdded(Object source, ElementType element, int newSize); 
	public void elementsAdded(Object source, Collection<? extends ElementType> element, int newSize); 
	public void elementInserted(Object source, ElementType element, int pos, int newSize); 
	public void elementChanged(Object source, ElementType element, int pos);
	public void elementRemoved(Object source, int pos, int newSize); 
	public void elementRemoved(Object source, ElementType element, int newSize); 
	public void elementsCleared(Object source);
	void elementSwapped (Object newParam, int index1, int index2);
	void elementSwapped (Object source, int index1, Object other, int index2);
	void elementMoved (Object source, int fromIndex, int toIndex);
	void elementMoved (Object source,int fromIndex, int fromNewSize, Object to, int toIndex);
	void elementCopied (Object source, int fromIndex, int toIndex, int newSize);
	void elementCopied (Object source,int fromIndex, int fromNewSize, Object to, int toIndex);
	void elementReplaced (Object source, int fromIndex, int toIndex, int newSize);
	void elementReplaced (Object source,int fromIndex, int newFromSize, Object to, int toIndex);
}
