package util.multicast;

import util.misc.Misc;
import util.models.BoundedBuffer;

public class AMessageReceiverRunnable implements Runnable {
	BoundedBuffer<AReceivedMessage> inputMessageQueue;
	MessageDelayer multicastClient;
	public AMessageReceiverRunnable(BoundedBuffer<AReceivedMessage> theMessageQueue,
			MessageDelayer theMulticastClient) {
		inputMessageQueue = theMessageQueue;
		multicastClient = theMulticastClient;
	}
	public void run() {		
		while (true) {
		try {
			AReceivedMessage message = inputMessageQueue.get();
			//long delay = multicastClient.getDelayToServer() - (System.currentTimeMillis() - message.timeStamp);
			long delay =  multicastClient.calculateDelay(message.timeStamp);
			if (delay > 0)
				Thread.sleep(delay);			
			switch (message.receivedMessageType) {
			case ClientLeft:
				multicastClient.delayedUserLeft(message.clientName, message.client, message.applicationName);				;
				break;
			case ClientJoined:
				//multicastServer.leave((String) args[0], (RemoteMulticastClient) args[1]);
				multicastClient.delayedUserJoined(message.clientName,  message.client, message.applicationName);				;
				break;
			case NewObject:
				//multicastServer.toOthers(args[0], (String) args[1], (RemoteMulticastClient) args[2]);
				multicastClient.delayedNewObject(message.clientName, message.newObject);
				break;		
			
			}
			
			
		} catch (Exception e) {
			e.printStackTrace();			
		}
		}

	}

}
