package util.multicast;

import java.awt.Frame;
import java.rmi.RemoteException;
import java.rmi.registry.Registry;
import java.rmi.server.UnicastRemoteObject;
import java.util.Collection;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import util.misc.Message;
import util.misc.Misc;
public class ASession extends ASessionListenable implements Session {
	Map <MessageReceiver, String>  clients = new HashMap();
	Map<String, MulticastGroup> multicastGroups = new HashMap();
	public ASession() {	
	}
	SerializedMulticastGroups toSerializedMulticastGroups() {
		SerializedMulticastGroups retVal = new ASerializedMulticastGroups();
		try {		
			for (String appName: multicastGroups.keySet()) {
				retVal.put(appName, multicastGroups.get(appName).getClients());
			}
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		return retVal;
		
	}
	public String[] getUserNames(MessageReceiver theClient) throws RemoteException {
		String[] values = {};
		values = clients.values().toArray(values);		
		return values;
	}
	@Override
	public Map<MessageReceiver, String> getClients(MessageReceiver theClient) throws RemoteException {
		// TODO Auto-generated method stub
		return clients;
	}

	@Override
	public JoinReturnValue join(String theClientName, MessageReceiver theClient, String theApplicationName) throws RemoteException { 

		//notifyClientJoined(theClientName, theClient, theApplicationName);
		//clients.put(theClient, theClientName);
		MulticastGroup multicastGroup = multicastGroups.get(theApplicationName);
		if (multicastGroup == null) {
			//multicastGroup = new AMulticastGroup(theApplicationName, clients);
			multicastGroup = new AMulticastGroup(theApplicationName);
			addSessionListener(multicastGroup);
			multicastGroup = (MulticastGroup) UnicastRemoteObject.exportObject(multicastGroup, 0);	
			multicastGroups.put(theApplicationName, multicastGroup);
		}
		notifyClientJoined(theClientName, theClient, theApplicationName);
		clients.put(theClient, theClientName);
		addSessionListener(theClient);
		JoinReturnValue retVal = new JoinReturnValue();
		retVal.multicastGroup = multicastGroup;
		retVal.clients = multicastGroup.getClients();
		retVal.serializedMulticastGroups = toSerializedMulticastGroups();
		return retVal;
	}
	@Override
	public void leave(String theClientName, MessageReceiver theClient, String theApplicationName) throws RemoteException {
		clients.remove(theClient);
		removeSessionListener(theClient);
//		for (MessageReceiver client:clients.keySet()) {			
//			client.userLeft(theClientName, theClient);			
//		}
		notifyClentLeft(theClientName, theClient, theApplicationName);
	}

	@Override
	public MulticastGroup getMulticastGroup(String theApplicationName) throws RemoteException {
		// TODO Auto-generated method stub
		return multicastGroups.get(theApplicationName);
	}	
}
