package util.multicast;

import java.rmi.RemoteException;
import java.rmi.registry.Registry;
import java.rmi.server.UnicastRemoteObject;
import java.util.HashMap;
import java.util.Map;

import util.misc.Message;
import util.misc.Misc;

public class ASessionManager implements SessionManager {
	Map<String, Session> sessions = new HashMap();
	public void ASessionManager() {
//		System.out.println("About to register");
//		register();
	}
	public JoinReturnValue join(String theSessionName, String theApplicationName, String clientName,  MessageReceiver client) throws RemoteException {
		Session session  = getOrCreateSession(theSessionName);
		JoinReturnValue retVal = session.join(clientName, client, theApplicationName);
		retVal.session = session;
		return retVal;
	}
	public void register () {
		try {
			Registry registry = util.misc.Misc.getOrCreateRegistry(  );
			SessionManager exportedServer = (SessionManager) UnicastRemoteObject.exportObject( this, 0);
			registry.rebind(SESSION_MANAGER_NAME, exportedServer);
			System.out.println ("Registered " + SESSION_MANAGER_NAME + " with RMI Server (" + Misc.getHostName() + ", " + Misc.DEFAULT_RMI_PORT+ ")");
		} catch (Exception e) {
			e.printStackTrace();
			Message.fatalError ("Could not register " + SESSION_MANAGER_NAME + " with RMI Server (" + Misc.getHostName() + ", " + Misc.DEFAULT_RMI_PORT+ ")");
		}		
	}
	@Override
	public Session createSession(String sessionName) throws RemoteException {
		Session session = new ASession();
		Session exportedSession = (Session) UnicastRemoteObject.exportObject( session, 0);
		sessions.put(sessionName, exportedSession);
		return exportedSession;
	}

	@Override
	public Session getOrCreateSession(String sessionName) throws RemoteException {
		Session remoteSession = sessions.get(sessionName);
		if (remoteSession == null)
			remoteSession = createSession(sessionName);
		return remoteSession;
	}

	@Override
	public void removeSession(String sessionName) throws RemoteException {
		sessions.remove(sessionName);
	}

}
