package util.multicast;

import java.rmi.RemoteException;
import java.util.Map;


public interface MessageSender {
	public void join(String serverHost, String theSessionName, String theApplicationName, String theClientName);
	public void leave();
	public void toOthers (Object object);
	public void toAll (Object object);
	public void toHost (String hostName, Object object);
	public void toHosts(String[] hostNames, Object object);
	public String getClientName();
	public int getMinimumDelayToServer();
	public void setMinimumDelayToServer(int theDelay);
	public int getDelayVariation();
	public void setDelayVariation(int theDelay) ;
	public void addReceivedMessageListener(ReceivedMessageListener listener);
	public void removeReceivedMessageListener(ReceivedMessageListener listener);
	public String[] getUserNames() throws RemoteException;
	public Map<MessageReceiver, String> getClients() throws RemoteException;
	
	
}
