package util.awt;
import java.awt.AWTEvent;
import java.awt.Dimension;
import java.awt.EventQueue;
import java.awt.Toolkit;
import java.awt.event.ComponentEvent;
import java.awt.event.HierarchyEvent;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.util.List;


import util.misc.Misc;
import util.multicast.AMulticastClient;
import util.multicast.MessageSender;
public class ADelegateEventQueue extends EventQueue implements DelegateEventQueue{
	static ADelegateEventQueue delegateEventQueue;
	List<EventQueueListener> eventQueueListeners = new ArrayList();	
	public ADelegateEventQueue() {
		if (delegateEventQueue != null)
			throw new RuntimeException("Call ADelegateEventQueue.getDelegateEventQueue() for an instance of this singleton");
		delegateEventQueue = this;
		EventQueue queue = Toolkit.getDefaultToolkit().getSystemEventQueue();	
		queue.push(this);	
	}
	public void addEventQueueListener(EventQueueListener listener) {
		if (eventQueueListeners.contains(listener)) return;
		eventQueueListeners.add(listener);
	}
	public void removeEventQueueListener(EventQueueListener listener) {		
		eventQueueListeners.remove(listener);
	}	
	public void dispatchEvent(ASerializableAWTEvent event) {
		if (event.getAWTEvent().getSource() != null)
		super.dispatchEvent(event.getAWTEvent());		
	}
	protected void dispatchEvent(AWTEvent event) {
		super.dispatchEvent(event);
		if (!(event.getSource() instanceof ADelegateFrame)) {
				return;
		}
		System.out.println("event:" + event);
		ASerializableAWTEvent serializedEvent = new ASerializableAWTEvent(event, event.paramString(), ComponentRegistry.getComponentId((ADelegateFrame) event.getSource()));
		for (EventQueueListener listener: eventQueueListeners) {
			listener.newEvent(serializedEvent);			
		}
	}
	public static ADelegateEventQueue getDelegateEventQueue() {
		if (delegateEventQueue == null)
			delegateEventQueue = new ADelegateEventQueue();
		return delegateEventQueue;
	}
}
